'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));
var semanticUiReact = require('semantic-ui-react');
var ReactDOM = _interopDefault(require('react-dom'));

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  wrapper: {
    position: "absolute",
    height: "100%",
    width: "100%",
    zIndex: 99999
  },
  menu: {
    position: "fixed",
    zIndex: 3000,
    width: "auto",
    boxShadow: "0 2px 4px 0 rgba(34,36,38,.12), 0 2px 10px 0 rgba(34,36,38,.15)"
  }
};

var Content = function (_React$Component) {
  _inherits(Content, _React$Component);

  function Content(props) {
    _classCallCheck(this, Content);

    var _this = _possibleConstructorReturn(this, (Content.__proto__ || Object.getPrototypeOf(Content)).call(this, props));

    _this.updatePosition = function () {
      var _this$props = _this.props,
          pageX = _this$props.pageX,
          pageY = _this$props.pageY;

      var menu = _this.el.querySelector("[data-id=menu]");
      var menuWidth = menu.offsetWidth;
      var menuHeight = menu.offsetHeight;
      var windowWidth = window.innerWidth;
      var windowHeight = window.innerHeight;
      var left = windowWidth - pageX < menuWidth ? windowWidth - menuWidth : pageX;
      var top = windowHeight - pageY < menuHeight ? windowHeight - menuHeight : pageY;

      if (pageX !== left || pageY !== top) {
        _this.setState({ top: top, left: left });
      }
    };

    _this.state = {
      top: props.pageY,
      left: props.pageX
    };
    return _this;
  }

  _createClass(Content, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.updatePosition();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          items = _props.items,
          onClose = _props.onClose,
          _onClick = _props.onClick;
      var _state = this.state,
          top = _state.top,
          left = _state.left;


      return React__default.createElement(
        "div",
        {
          ref: function ref(el) {
            _this2.el = el;
          },
          style: styles.wrapper,
          onClick: onClose,
          onContextMenu: function onContextMenu(evt) {
            evt.preventDefault();
            onClose();
          }
        },
        React__default.createElement(
          semanticUiReact.Menu,
          {
            vertical: true,
            "data-id": "menu",
            style: _extends({}, styles.menu, {
              top: top,
              left: left
            })
          },
          items.map(function (i) {
            return React__default.createElement(semanticUiReact.Menu.Item, _extends({}, i, {
              style: { whiteSpace: "nowrap" },
              onClick: function onClick(evt) {
                evt.stopPropagation();
                _onClick(evt, i);
              }
            }));
          })
        )
      );
    }
  }]);

  return Content;
}(React__default.Component);

Content.propTypes = {
  items: PropTypes.array.isRequired,
  pageY: PropTypes.number.isRequired,
  pageX: PropTypes.number.isRequired,
  onClose: PropTypes.func.isRequired,
  onClick: PropTypes.func.isRequired
};

var _extends$1 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass$1 = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck$1(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn$1(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits$1(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var div = document.createElement("div");

var ContextMenu = function (_React$Component) {
  _inherits$1(ContextMenu, _React$Component);

  function ContextMenu() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck$1(this, ContextMenu);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn$1(this, (_ref = ContextMenu.__proto__ || Object.getPrototypeOf(ContextMenu)).call.apply(_ref, [this].concat(args))), _this), _this.mountContent = function (event) {
      var _this$props = _this.props,
          items = _this$props.items,
          _onClick = _this$props.onClick;
      var pageX = event.pageX,
          pageY = event.pageY;

      var contentProps = {
        items: items,
        pageX: pageX,
        pageY: pageY
      };

      document.body.appendChild(div);

      ReactDOM.render(React__default.createElement(Content, _extends$1({}, contentProps, {
        onClose: _this.unmountContent,
        onClick: function onClick(evt, item) {
          _this.unmountContent();
          _onClick(evt, item);
        }
      })), div);
    }, _this.unmountContent = function () {
      var didUnmount = ReactDOM.unmountComponentAtNode(div);

      if (didUnmount && div.parentNode) {
        div.parentNode.removeChild(div);
      }
    }, _this.handleContextMenu = function (evt) {
      evt.preventDefault();
      _this.mountContent(evt);
    }, _temp), _possibleConstructorReturn$1(_this, _ret);
  }

  _createClass$1(ContextMenu, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unmountContent();
    }
  }, {
    key: "render",
    value: function render() {
      var trigger = this.props.trigger;


      return React.cloneElement(trigger, {
        onContextMenu: this.handleContextMenu
      });
    }
  }]);

  return ContextMenu;
}(React__default.Component);

ContextMenu.propTypes = {
  trigger: PropTypes.node.isRequired,
  items: PropTypes.array.isRequired,
  onClick: PropTypes.func.isRequired
};

module.exports = ContextMenu;
